'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isBrowser = typeof document !== 'undefined';
var isServer = !isBrowser && typeof process !== 'undefined' && process.title !== 'browser';

function deepClone(object) {
  if (object == null || (typeof object === 'undefined' ? 'undefined' : (0, _typeof3.default)(object)) !== 'object') return object;

  return JSON.parse((0, _stringify2.default)(object));
}

function fastEqual(object1, object2) {
  return (0, _stringify2.default)(object1) === (0, _stringify2.default)(object2);
}

exports.default = {
  deepClone: deepClone,
  fastEqual: fastEqual,
  isBrowser: isBrowser,
  isServer: isServer
};
module.exports = exports['default'];